﻿local Speed = _G.LibStub("LibDataBroker-1.1"):NewDataObject("Broker_Speed", {
	icon = "Interface\\Icons\\Ability_Rogue_Sprint.blp",
	label = "Speed",
	suffix = "%",
})

local value = 0

local FREQUENCY = 0.5
local frame
local zoneBaseRate = {
	Durotar = 5287.5,
	Mulgore = 5137.5,
	Barrens = 10133.34,
	Kalimdor = 36799.8,
	Azeroth = 40741.2,
	Alterac = 2800.003,
	Arathi = 3600.003,
	Badlands = 2487.5,
	BlastedLands = 3350,
	Tirisfal = 4518.75,
	Silverpine = 4200,
	WesternPlaguelands = 4299.997,
	EasternPlaguelands = 3870.83,
	Hilsbrad = 3200,
	Hinterlands = 3850,
	DunMorogh = 4925,
	SearingGorge = 2231.253,
	BurningSteppes = 2929.163,
	Elwynn = 3470.84,
	DeadwindPass = 2499.997,
	Duskwood = 2700.003,
	LochModan = 2758.33,
	Redridge = 2170.84,
	Stranglethorn = 6381.25,
	SwampOfSorrows = 2293.75,
	Westfall = 3500.003,
	Wetlands = 4135.417,
	Teldrassil = 5091.66,
	Darkshore = 6550,
	Ashenvale = 5766.67,
	ThousandNeedles = 4399.997,
	StonetalonMountains = 4883.33,
	Desolace = 4495.83,
	Feralas = 6950,
	Dustwallow = 5250,
	Tanaris = 6900,
	Aszhara = 5070.84,
	Felwood = 5750,
	UngoroCrater = 3700.003,
	Moonglade = 2308.33,
	Silithus = 3483.334,
	Winterspring = 7100.003,
	Stormwind = 1344.2694,
	Ogrimmar = 1402.61,
	Ironforge = 790.629,
	ThunderBluff = 1043.75,
	Darnassis = 1058.33,
	Undercity = 959.3754,
	AlteracValley = 4237.5,
	WarsongGulch = 1145.837,
	ArathiBasin = 1756.247,
	EversongWoods = 4925,
	Ghostlands = 3300,
	AzuremystIsle = 4070.8,
	Hellfire = 5164.58,
	Expansion01 = 17464.04,
	Zangarmarsh = 5027.08,
	TheExodar = 1056.7,
	ShadowmoonValley = 5500,
	BladesEdgeMountains = 5425,
	BloodmystIsle = 3262.5,
	Nagrand = 5524.97,
	TerokkarForest = 5400,
	Netherstorm = 5574.9967,
	SilvermoonCity = 1211.46,
	ShattrathCity = 1306.25,
	NetherstormArena = 2270.837,
	Sunwell = 3327.09,
}

local function round(x)
	if x - floor(x) > 0.5 then
		x = floor(x + 0.5)
	else
		if x - floor(x) > 0.25 then
			x = floor(x) + 0.5
		else
			x = floor(x)
		end
	end
	return x
end

local difference = 0
local lastPos, currPos, lastTime, iDeltaTime, fSpeed, fSpeedDist

local function UpdateSpeed(frame,elapsed)
	difference = difference + elapsed
	if difference < FREQUENCY then
		return
	end
	
	-- Initialize.
	if (lastPos == nil) then
		lastTime = time()
		iDeltaTime = 0
		fSpeed = 0.0
		fSpeedDist = 0.0
		currPos = {}
		lastPos = {}
		lastPos.m, lastPos.x, lastPos.y = GetMapInfo(), GetPlayerMapPosition("player")
	end
	
	iDeltaTime = iDeltaTime + difference;
	currPos.m, currPos.x, currPos.y = GetMapInfo(), GetPlayerMapPosition("player")
	
	if ((currPos.x == 0) and (currPos.y == 0)) or (lastPos.m ~= currPos.m) then
		fSpeed = "-"
		fSpeedDist = 0.0
		iDeltaTime = 0.0
	else
		local dist = math.sqrt(
			((lastPos.x - currPos.x) * (lastPos.x - currPos.x) * 2.25 ) +
			((lastPos.y - currPos.y) * (lastPos.y - currPos.y))
			)
		
		fSpeedDist = fSpeedDist + dist
		
		if (iDeltaTime >= .5) then
			local zone = currPos.m
			local displacement = (fSpeedDist / iDeltaTime)
			local baserate
			
			baserate = zoneBaseRate[zone]
			
			if (baserate ~= nil and baserate ~= 0) then
				fSpeed = round( (displacement / (10.5 / baserate)) * 100)
				fSpeedDist = 0.0
				iDeltaTime = 0.0
			else
				fSpeed = "-"
				fSpeedDist = 0.0
				iDeltaTime = 0.0
			end
		end 
	end
	
	lastPos.m = currPos.m
	lastPos.x = currPos.x
	lastPos.y = currPos.y
	
	local color = 'ffffff'

	if fSpeed == nil or fSpeed == "-" then
		fSpeed = "?"
	else
		if fSpeed > 100 then
			color = "ff00ff"
		elseif fSpeed < 100 then
			color = "ffff00"
		end
	end
	difference = 0
	
	Speed.value = fSpeed
	Speed.text = string.format("|c%s00%s%s|r", color, fSpeed, Speed.suffix)
end

frame = CreateFrame("Frame")
frame:SetScript("OnEvent",function(frame,event,...)
	if not WorldMapFrame:IsShown() then
		SetMapToCurrentZone()
		lastPos = nil
	end
end)
frame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
frame:SetScript("OnUpdate", UpdateSpeed)
